#ifndef _ENEMY_H
#define _ENEMY_H

#include "map.h"
#include "player.h"


typedef enum
{
    ENEMY_IDLE,
    ENEMY_SHOOTING,
    ENEMY_DEAD
} enemy_state_t;


/* What the enemy can shoot */
typedef struct
{
    pos_t       pos;
    char        symbol;
    direction_t dir;
} shoot_t;


typedef struct _enemy_t
{
    pos_t            pos;
    char             symbol;
    shoot_t          shoot;
    enemy_state_t    state;
    struct _enemy_t *next;
} enemy_t;


/* Load enemies from the map (destroy with enemy_free_enemies) */
extern enemy_t *enemy_load_enemies(const map_t *map);


/* Release resource */
extern void enemy_free_enemies(enemy_t *enemies);


/* Update the enemies (like shoot things) 
 * If a player is hit, they are updated accordingly
 */
extern void enemy_update(
    enemy_t     *enemies,
    player_t    *player,
    const map_t *map);


#endif /* _ENEMY_H */
