#ifndef _MAIN_H
#define _MAIN_H

#include <stdio.h>
#include <stdlib.h>


#define TAG  "[dios]"
#define NAME "Dilldongs in Outter Space"
#define VER  "0.1"


/* Seconds to run the game before it ends */
#define TIMEOUT 45


#define ERR_FAIL(...)                            \
{                                                \
    fprintf(stderr, TAG "[error] " __VA_ARGS__); \
    fputc('\n', stderr);                         \
    exit(EXIT_FAILURE);                          \
}


#define OUT(...)                 \
{                                \
    printf(TAG " " __VA_ARGS__); \
    putc('\n', stdout);          \
}


#define OUT_DEBUG(...)                  \
{                                       \
    printf(TAG "[debug] " __VA_ARGS__); \
    putc('\n', stdout);                 \
}


/* Game status */
typedef enum
{
    GAME_OVER,
    GAME_OVER_WIN,
    GAME_ON
} game_status_t;


/* If we have loss */
#define GAME_LOSS(_st) ((_st) == GAME_OVER)


#endif /* _MAIN_H */
